<?php

namespace seraph_accel;

if( !defined( 'ABSPATH' ) )
	exit;

require( __DIR__ . '/common.php' );

$hr = _Process( $seraph_accel_sites, $_GET );
if( $hr == Gen::S_OK || Gen::HrFail( $hr ) )
{
	CacheDoCronAndEndRequest();
	return;
}

if( $hr == Gen::S_IO_PENDING )
	ob_start( 'seraph_accel\\_CbContentFinish' );
else if( $seraph_accel_g_cacheSkipData )
	ob_start( 'seraph_accel\\_CbContentFinishSkip' );

unset( $seraph_accel_sites );

function _Process( $sites, $args )
{

	if( @$_SERVER[ 'REQUEST_METHOD' ] != 'GET' )
		return( Gen::S_FALSE );

	global $seraph_accel_g_jkfjkexiydyved;
	global $seraph_accel_g_prepPrms;

	$seraph_accel_g_prepPrms = CacheExtractPreparePageParams( $args );
	if( $seraph_accel_g_prepPrms )
	{
		ignore_user_abort( true );
		set_time_limit( 300 );

	}

	if( GetContCacheEarlySkipData( $path, $args ) )
		return( Gen::S_FALSE );

	global $seraph_accel_g_cacheSkipData;

	{
		$host = GetRequestHost( $_SERVER );
		$siteId = GetCacheSiteIdAdjustPath( $sites, $host, $path );
		if( $siteId == '_' )
		{
			$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'siteIdUnk' ) );
			return( Gen::S_FALSE );
		}

		unset( $host );
	}

	$sett = Plugin::SettGet( Gen::CallFunc( 'seraph_accel_siteSettInlineDetach', array( $siteId ) ) );
	$settCache = Gen::GetArrField( $sett, array( 'cache' ), array() );

	{
		if( @$sett[ 'debug' ] && isset( $args[ 'seraph_accel_proc' ] ) )
		{
			$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'debugContProcForce' ) );
			return( Gen::S_FALSE );
		}
	}

	{
		$exclStatus = ContProcGetExclStatus( $siteId, $settCache, $path, $args, $varsOut );
		if( $exclStatus )
		{
			if( @$sett[ 'hdrTrace' ] )
				_ProcessOutHdrTrace( 'skipped', array_merge( array( 'reason' => $exclStatus ),
					@$sett[ 'debugInfo' ] ? array( '_SERVER' => $_SERVER ) : array()
				) );

			return( Gen::S_FALSE );
		}

		extract( $varsOut );
		unset( $varsOut );
		unset( $exclStatus );
	}

	$sessId = $userId ? @$sessInfo[ 'userSessId' ] : @$sessInfo[ 'sessId' ];
	$viewId = GetCacheViewId( $settCache, $userAgent, $args );
	$cacheRootPath = GetCacheDir();
	$siteCacheRootPath = $cacheRootPath . '/s/' . $siteId;
	$ctxsPath = GetCacheViewsDir( $siteCacheRootPath ) . '/' . $viewId . '/c';

	{
		if( !$sessId || !$stateCookId || !Gen::GetArrField( $settCache, array( 'ctxSessSep' ), false ) )
			$sessId = '@';

		$ctxPathId = $userId . '/s/' . $sessId;

		if( $stateCookId )
			$stateCookId = md5( $stateCookId );
		else
			$stateCookId = '@';

		$ctxPathId .= '/s/' . $stateCookId;
	}

	$objectId = '@';
	if( !empty( $args ) )
	{
		$argsCumulative = '';
		foreach( $args as $argKey => $argVal )
			$argsCumulative .= $argKey . $argVal;

		$objectId = $objectId . '.' . @md5( $argsCumulative );
		unset( $argsCumulative );
	}

	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dscFilePending;
	global $seraph_accel_g_dataPath;

	$seraph_accel_g_dataPath = GetCacheDataDir( $siteCacheRootPath );

	$seraph_accel_g_dscFile = $ctxsPath . '/' . $ctxPathId . '/o';
	if( $path )
		$seraph_accel_g_dscFile .= '/' . $path;
	$seraph_accel_g_dscFile .= '/' . $objectId . '.html.dat';

	$seraph_accel_g_dscFilePending = $seraph_accel_g_dscFile . '.p';

	if( $seraph_accel_g_prepPrms !== null )
	{
		$dscFileTm = null;
		if( @$seraph_accel_g_prepPrms[ 'force' ] || CacheContentStart( $tmCur, $dscFileTm ) )
		{
			$seraph_accel_g_jkfjkexiydyved = true;
			return( Gen::S_IO_PENDING );
		}

		return( Gen::S_OK );
	}

	$asyncRevalidate = Gen::GetArrField( $sett, array( 'contPr', 'enable' ), false );

	$timeout = Gen::GetArrField( $settCache, array( 'timeout' ), 0 ) * 60;

	$iiuhwehfdywdyxsqsiy = null;
	$dscFileTm = @filemtime( $seraph_accel_g_dscFile );
	if( $dscFileTm === false )
	{
		$ccs = CacheContentStart( $tmCur, $dscFileTm );
		if( $ccs === true )
		{
			if( $asyncRevalidate )
			{

				$seraph_accel_g_cacheSkipData = array( 'revalidating-begin', array( 'reason' => 'firstTime', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) ) );
				return( Gen::S_FALSE );
			}

			return( Gen::S_IO_PENDING );
		}

		if( $ccs === false )
		{
			$seraph_accel_g_cacheSkipData = array( 'revalidating', array( 'reason' => 'firstTime', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) ) );
			return( Gen::S_FALSE );
		}
	}
	else
	{
		$sessExpiration = @$sessInfo[ 'expiration' ];
		if( !$sessExpiration )
			$sessExpiration = $tmCur;

		$httpCacheControl = strtolower( @$_SERVER[ 'HTTP_CACHE_CONTROL' ] );

		$lazyInv = @$settCache[ 'lazyInv' ] && $sessId == '@';

		$dscFileTmAge = $tmCur - $dscFileTm;
		if( $dscFileTm === 0  || ( $timeout > 0 && $dscFileTmAge > $timeout ) || $tmCur > $sessExpiration || ( $sessId != '@' && $httpCacheControl == 'no-cache' && Gen::GetArrField( $settCache, array( 'ctxCliRefresh' ), false ) ) )
		{
			$ccs = CacheContentStart( $tmCur, $dscFileTm );
			if( $ccs === true )
			{

				if( $lazyInv )
					$iiuhwehfdywdyxsqsiy = false;
				else

				{
					if( $asyncRevalidate )
					{

						$seraph_accel_g_cacheSkipData = array( 'revalidating-begin', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) );
						return( Gen::S_FALSE );
					}

					return( Gen::S_IO_PENDING );
				}
			}
			else if( $ccs === false )
				$iiuhwehfdywdyxsqsiy = true;
		}
	}

	$dsc = CacheReadDsc( $seraph_accel_g_dscFile );
	if( !$dsc )
	{
		if( !$iiuhwehfdywdyxsqsiy && CacheContentStart( $tmCur, $dscFileTm ) === true )
		{
			if( $asyncRevalidate )
			{

				$seraph_accel_g_cacheSkipData = array( 'revalidating-begin', array( 'reason' => 'brokenDsc', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) ) );
				return( Gen::S_FALSE );
			}

			return( Gen::S_IO_PENDING );
		}

		$seraph_accel_g_cacheSkipData = array( 'revalidating', array( 'reason' => 'brokenDsc', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) ) );
		return( Gen::S_FALSE );
	}

	$output = null;
	$hr = _ProcessOutCachedData( $sett, $settCache, $dsc, $dscFileTm, $tmCur, $iiuhwehfdywdyxsqsiy ? 'revalidating' : ( $iiuhwehfdywdyxsqsiy === false ? 'revalidating-begin' : 'cache' ), true, $output );
	if( Gen::HrFail( $hr ) )
		return( $hr );

	if( $hr == Gen::S_FALSE )
	{
		if( CacheContentStart( $tmCur, $dscFileTm ) === true )
		{
			if( $asyncRevalidate )
			{

				$seraph_accel_g_cacheSkipData = array( 'revalidating-begin', array( 'reason' => 'brokenData', 'dscFile' => substr( $seraph_accel_g_dscFile, strlen( $cacheRootPath ) ) ) );
				return( Gen::S_FALSE );
			}

			return( Gen::S_IO_PENDING );
		}
	}
	else if( $iiuhwehfdywdyxsqsiy === false )
	{
		Gen::CloseCurRequestSessionForContinueBgWork();

		if( $asyncRevalidate || !function_exists( 'fastcgi_finish_request' ) )
		{
			CacheSetCurRequestToPrepareAsync( true );
			return( Gen::S_FALSE );
		}

		$seraph_accel_g_jkfjkexiydyved = true;
		return( Gen::S_IO_PENDING );
	}

	return( $hr );
}

function _ProcessOutHdrTrace( $state, $data = null, $dscFile = null )
{
	$debugInfo = ' state=' . $state . ';';
	if( $dscFile )
		$debugInfo .= ' dscFile="' . substr( $dscFile, strlen( GetCacheDir() ) ) . '";';

	if( is_array( $data ) )
		foreach( $data as $dataK => $dataV )
		{
			$v = '';
			switch( gettype( $dataV ) )
			{
			case 'array':		$v = @json_encode( $dataV, JSON_INVALID_UTF8_IGNORE ); break;
			case 'string':		$v = '"' . $dataV . '"'; break;
			case 'boolean':		$v = $dataV ? 'true' : 'false'; break;
			default:			$v .= $dataV; break;
			}

			$debugInfo .= ' ' . $dataK . '=' . $v . ';';
		}

	header( 'X-seraph-accel-Cache: 1.8.7;' . $debugInfo );
}

function _ProcessOutCachedData( $sett, $settCache, $dsc, $dscFileTm, $tmCur, $stateValidate, $out, &$output )
{
	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dataPath;

	$encoding = '';

	$acceptEncodings = array_map( 'trim', explode( ',', strtolower( @$_SERVER[ 'HTTP_ACCEPT_ENCODING' ] ) ) );
	{
		$acceptEncodingsRaw = $acceptEncodings;
		$acceptEncodings = array();
		foreach( $acceptEncodingsRaw as $acceptEncodingRaw )
		{
			$parts = array_map( 'trim', explode( ';', $acceptEncodingRaw ) );
			if( count( $parts ) )
			{
				$parts = $parts[ 0 ];
				if( $parts != 'br' || IsBrotliAvailable() )
					$acceptEncodings[ $parts ] = true;
			}
		}

		unset( $parts );
		unset( $acceptEncodingsRaw );
		unset( $acceptEncodingRaw );
	}

	$encs = Gen::GetArrField( $settCache, array( 'encs' ), array() );

	{
		foreach( $encs as $enc )
		{
			if( $enc === '' )
				continue;

			if( $acceptEncodings[ $enc ] )
			{
				$encoding = $enc;
				break;
			}
		}
	}
	unset( $encs );
	unset( $acceptEncodings );

	$ctxData = CacheDscGetDataCtx( $settCache, $dsc, $encoding, $seraph_accel_g_dataPath, $tmCur, 'html' );
	if( !$ctxData )
	{

		@unlink( $seraph_accel_g_dscFile );
		return( Gen::S_FALSE );
	}

	if( $encoding )
	{
		@ini_set( 'zlib.output_compression', 'Off' );
		@ini_set( 'brotli.output_compression', 'Off' );
	}

	header( 'Cache-Control: no-cache, must-revalidate, max-age=0' );
	header( 'Pragma: no-cache' );
	header( 'Expires: Wed, 11 Jan 1984 05:00:00 GMT' );
	header( 'Content-Type: text/html' );
	header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s', $dscFileTm ) . ' GMT' );

	if( $ctxData[ 'sizeRaw' ] !== null )
		header( 'Content-Length: '. $ctxData[ 'sizeRaw' ] );

	if( $encoding )
		header( 'Content-Encoding: ' . $encoding );

	if( @$sett[ 'hdrTrace' ] )
	{
		$debugData = array_merge( array_filter( $ctxData, function( $k ) { return( in_array( $k, array( 'encoding', 'recompress', 'compressedEncoding', 'sizeRaw', 'size' ) ) ); }, ARRAY_FILTER_USE_KEY ), array(),
			@$sett[ 'debugInfo' ] ? array( '_SERVER' => $_SERVER ) : array()
		);

		_ProcessOutHdrTrace( $stateValidate,
			$debugData,
			$seraph_accel_g_dscFile );
	}

	$output = CacheDscDataOutput( $ctxData, $out );
	if( $output !== false )
		return( Gen::S_OK );

	@unlink( $seraph_accel_g_dscFile );
	return( Gen::E_FAIL );
}

function ubyvjdujdesadkxsjuw_( $tyadkxs, $encoding, $dataPath, $tmUpdate, $type, $dataComprExts )
{
	$tyadkxs .= '.' . $type;

	$ext = _GetDataFileEncExt( $encoding, $type );
	if( $ext === null || !in_array( $ext, $dataComprExts ) )
		return( null );

	$ubyvadkxs = $dataPath . '/' . $tyadkxs . $ext;

	$file = @fopen( $ubyvadkxs, 'rb' );
	if( !$file )
		return( null );

	@touch( $ubyvadkxs, $tmUpdate );
	return( array( 'path' => $ubyvadkxs, 'stm' => $file, 'fmt' => $ext ) );
}

function jdujdesubyvadkxsjuw_( $ubyvadkxs, $out = false )
{
	if( !$out )
		return( @file_get_contents( $ubyvadkxs[ 'path' ] ) );

	$file = $ubyvadkxs[ 'stm' ];

	while( !@feof( $file ) && ( @connection_status() == 0 ) )
		CacheWriteOut( @fread( $file, 0x10000 ) );

	return( true );
}

function CacheDscGetDataCtxFirstFile( $tyadkxs, &$ctxData, $dataPath, $tmUpdate, $type, $dataComprExts )
{
	$encoding = $ctxData[ 'encoding' ];

	$ubyvadkxs = ubyvjdujdesadkxsjuw_( $tyadkxs, $encoding, $dataPath, $tmUpdate, $type, $dataComprExts );
	if( $ubyvadkxs )
	{
		$ctxData[ 'compressedEncoding' ] = $encoding;
		return( $ubyvadkxs );
	}

	$ctxData[ 'recompress' ] = true;

	$encodings = array( '', 'gzip', 'deflate', 'compress', 'br' );
	if( !in_array( $encoding, $encodings ) )
		return( null );

	foreach( $encodings as $encoding )
	{
		$ubyvadkxs = ubyvjdujdesadkxsjuw_( $tyadkxs, $encoding, $dataPath, $tmUpdate, $type, $dataComprExts );
		if( $ubyvadkxs )
		{
			$ctxData[ 'compressedEncoding' ] = $encoding;
			return( $ubyvadkxs );
		}
	}

	return( null );
}

function CacheDscGetDataCtx( $settCache, $dsc, $encoding, $dataPath, $tmUpdate, $type )
{
	$iadkxs = @$dsc[ 'p' ];
	if( !is_array( $iadkxs ) || count( $iadkxs ) != 1 )
		return( null );

	$dataComprExts = Gen::GetArrField( $settCache, array( 'dataCompr' ), array() );
	if( empty( $dataComprExts ) )
		$dataComprExts[] = '';
	foreach( $dataComprExts as &$dataComprExt )
		$dataComprExt = _GetDataFileComprExt( $dataComprExt, $type );

	$ctxData = array( 'encoding' => $encoding, 'recompress' => false, 'iubyv' => array() );
	{
		$tyadkxs = $iadkxs[ 0 ];

		$ubyvadkxs = CacheDscGetDataCtxFirstFile( $tyadkxs, $ctxData, $dataPath, $tmUpdate, $type, $dataComprExts );
		if( !$ubyvadkxs )
			return( null );

		$ctxData[ 'fmt' ] = $ubyvadkxs[ 'fmt' ];
	}

	$fmt = $ctxData[ 'fmt' ];

	if( !$ctxData[ 'recompress' ] )
	{
		switch( $encoding )
		{
		case 'deflate':
			if( $fmt != '.deflu' )
				$ctxData[ 'recompress' ] = true;
			break;

		case 'compress':
			if( $fmt != '.deflu' )
				$ctxData[ 'recompress' ] = true;
			break;

		}
	}

	$recompress = $ctxData[ 'recompress' ];

	$size = 0;
	$sizeRaw = 0;
	$content = '';

		$ctxData[ 'iubyv' ][] = $ubyvadkxs;
		$size += upyiwyheadkxsuxsqsjuw( $tyadkxs );

		if( $recompress )
		{
			$qjqtadkxs = jdujdesubyvadkxsjuw_( $ubyvadkxs );
			if( $qjqtadkxs === false )
				return( null );

			switch( $fmt )
			{
			case '.gz':				$qjqtadkxs = @gzdecode( $qjqtadkxs ); break;
			case '.deflu':		$qjqtadkxs = @gzinflate( $qjqtadkxs . "\x03\0" ); break;
			case '.br':				$qjqtadkxs = Gen::CallFunc( 'brotli_uncompress', array( $qjqtadkxs ), false ); break;
			case '.brua':		$qjqtadkxs = Gen::CallFunc( 'brotli_uncompress', array( "\x6b\x00" . $qjqtadkxs . "\x03" ), false ); break;
			}

			if( $qjqtadkxs === false )
				return( null );

			$content .= $qjqtadkxs;
		}
		else
			$sizeRaw += @filesize( $ubyvadkxs[ 'path' ] );

	if( !$recompress )
	{
		switch( $encoding )
		{
		case 'deflate':
			if( $fmt == '.deflu' )
				$sizeRaw += 2;
			break;

		case 'compress':
			if( $fmt == '.deflu' )
				$sizeRaw += 2 + 2 + 4;
			break;

		case 'gzip':
			if( $fmt == '.deflu' )
				$sizeRaw += 10 + 2 + 4 + 4;
			break;

		case 'br':
			if( $fmt == '.brua' )
				$sizeRaw += 2 + 1;
			break;
		}
	}
	else
	{
		switch( $encoding )
		{
		case 'deflate':		$content = @gzdeflate( $content, 6 ); break;
		case 'compress':	$content = @gzcompress( $content, 6 ); break;
		case 'gzip':		$content = @gzencode( $content, 6 ); break;
		case 'br':			$content = Gen::CallFunc( 'brotli_compress', array( $content, 7 ), false ); break;
		}

		if( $content === false )
			return( null );

		$sizeRaw = strlen( $content );
	}

	$ctxData[ 'content' ] = $content;
	$ctxData[ 'size' ] = $size;
	$ctxData[ 'sizeRaw' ] = $sizeRaw;
	$ctxData[ 'crc32' ] = $dsc[ 'c' ];
	$ctxData[ 'adler32' ] = $dsc[ 'a' ];
	return( $ctxData );
}

function CacheDscDataOutput( $ctxData, $out = true )
{
	$iubyvadkxs = $ctxData[ 'iubyv' ];
	$encoding = $ctxData[ 'encoding' ];
	$recompress = $ctxData[ 'recompress' ];
	$fmt = $ctxData[ 'fmt' ];

	if( !$iubyvadkxs )
		return( false );

	if( $recompress )
	{
		$content = $ctxData[ 'content' ];
		if( !$out )
			return( $content );

		CacheWriteOut( $content );
		return( true );
	}

	$content = '';

	switch( $encoding )
	{
	case 'deflate':
		break;

	case 'compress':
		if( $fmt == '.deflu' )
		{
			$qjqtadkxs = "\x78\xDA";
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;

	case 'gzip':
		if( $fmt == '.deflu' )
		{
			$qjqtadkxs = "\x1F\x8B\x08\0\0\0\0\0\x02\x0A";
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;

	case 'br':
		if( $fmt == '.brua' )
		{
			$qjqtadkxs = "\x6b\x00";
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;
	}

		$ubyvadkxs = $iubyvadkxs[ 0 ];

		$qjqtadkxs = jdujdesubyvadkxsjuw_( $ubyvadkxs, $out );
		if( $qjqtadkxs === false )
			return( false );

		if( !$out )
			$content .= $qjqtadkxs;

	switch( $encoding )
	{
	case 'deflate':
		if( $fmt == '.deflu' )
		{
			$qjqtadkxs = "\x03\0";
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;

	case 'compress':
		if( $fmt == '.deflu' )
		{
			$qjqtadkxs = "\x03\0" . $ctxData[ 'adler32' ];
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;

	case 'gzip':
		if( $fmt == '.deflu' )
		{
			$qjqtadkxs = "\x03\0" . $ctxData[ 'crc32' ] . pack( 'V', $ctxData[ 'size' ] );
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;

	case 'br':
		if( $fmt == '.brua' )
		{
			$qjqtadkxs = "\x03";
			if( $out )
				CacheWriteOut( $qjqtadkxs );
			else
				$content .= $qjqtadkxs;
		}
		break;
	}

	if( !$out )
		return( $content );

	CacheWriteOut( $content );
	return( true );
}

function CacheWriteOut( $data )
{

	print( $data );
}

function CacheDscWriteCancel()
{
	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dscFilePending;

	@unlink( $seraph_accel_g_dscFilePending );

	@unlink( $seraph_accel_g_dscFile );
}

function CacheDscUpdate( $settCache, $content, $children, $dataPath )
{
	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dscFilePending;

	$dsc = array( 'p' => array() );

	$writeOk = true;

	function ujyhmadkxsjdujdes_( &$dsc, $data, $settCache, $dataPath )
	{
		if( !$data )
			return( true );

		$adkxs = ujyhmadkxsuxsqs( $settCache, $dataPath, $data, 'html' );
		if( !$adkxs )
			return( false );

		$dsc[ 'p' ][] = $adkxs[ 'id' ];
		return( true );
	}

		$writeOk = ujyhmadkxsjdujdes_( $dsc, $content, $settCache, $dataPath );

	$dsc[ 'c' ] = pack( 'V', crc32( $content ) );
	$dsc[ 'a' ] = hash( 'adler32', $content, true );

	if( $children )
		$dsc[ 's' ] = $children;

	if( $writeOk )
	{
		$dscFileNew = $seraph_accel_g_dscFile . '.new';

		if( @file_put_contents( $dscFileNew, @serialize( $dsc ) ) === false )
			$writeOk = false;
		if( $writeOk && !@rename( $dscFileNew, $seraph_accel_g_dscFile ) )
			$writeOk = false;

		if( !$writeOk )
			@unlink( $dscFileNew );
	}

	$ulr = @unlink( $seraph_accel_g_dscFilePending );

	return( $writeOk ? $dsc : null );
}

function CacheSetCurRequestToPrepareAsyncEx()
{
	$serverArgsTmp = Gen::ArrCopy( $_SERVER ); CorrectRequestScheme( $serverArgsTmp, 'client' );
	CachePostPreparePage( $serverArgsTmp[ 'REQUEST_SCHEME' ] . '://' . GetRequestHost( $serverArgsTmp ) . $serverArgsTmp[ 'REQUEST_URI' ], 10, Net::GetRequestHeaders(), true );
}

function CacheSetCurRequestToPrepareAsync( $endRequest = false )
{
	add_action( 'muplugins_loaded', function() { CacheSetCurRequestToPrepareAsyncEx(); } , 0 );
	if( !$endRequest )
		return;

	if( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON )
		add_action( 'muplugins_loaded', function() { exit(); }, 1 );
	else
		add_action( 'wp_loaded', function() { exit(); }, 999999 );
}

function CacheDoCronAndEndRequest()
{
	if( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON )
	{
		flush();
		exit();
	}

	Gen::CloseCurRequestSessionForContinueBgWork();
	add_action( 'wp_loaded', function() { exit(); }, 999999 );
}

function CacheContentStart( $tmCur, &$dscFileTm )
{
	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dscFilePending;

	for( $try = 1; $try <= 2; $try++ )
	{
		$stm = null;
		$hr = Gen::FileOpenWithMakeDir( $stm, $seraph_accel_g_dscFilePending, 'x' );
		if( $stm )
		{
			@fclose( $stm );
			break;
		}

		if( $try == 2 )
			return( false );

		$dscFilePendingTm = @filemtime( $seraph_accel_g_dscFilePending );
		if( $dscFilePendingTm !== false && ( $tmCur - $dscFilePendingTm < 300 ) )
			return( false );

		@unlink( $seraph_accel_g_dscFilePending );
	}

	$dscFileTm = @filemtime( $seraph_accel_g_dscFile );
	if( ( $dscFileTm !== false ) && ( $dscFileTm > $tmCur ) )
	{
		@unlink( $seraph_accel_g_dscFilePending );
		return( null );
	}

	return( true );
}

function _CbContentFinishSkip( $content )
{
	global $seraph_accel_g_cacheSkipData;

	if( $seraph_accel_g_cacheSkipData[ 0 ] === 'revalidating-begin' )
	{
		$beginPrepare = false;

		$cacheSkipData = $seraph_accel_g_cacheSkipData;
		$seraph_accel_g_cacheSkipData = null;
		if( !GetContCacheEarlySkipData( $path, $args ) )
		{
			$skipStatus = ContProcGetSkipStatus( $content );
			if( $skipStatus )
				$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => $skipStatus ) );
			else
			{
				$seraph_accel_g_cacheSkipData = $cacheSkipData;
				$beginPrepare = true;
			}
		}

		if( $beginPrepare )
			CacheSetCurRequestToPrepareAsyncEx();
		else
			CacheDscWriteCancel();
	}

	$sett = Plugin::SettGet();
	$settCache = Gen::GetArrField( $sett, array( 'cache' ), array() );

	if( @$settCache[ 'log' ] )
		LogWrite( 'cache: ' . $seraph_accel_g_cacheSkipData[ 0 ] . '. Data dump: ' . @json_encode( @$seraph_accel_g_cacheSkipData[ 1 ] ), Ui::MsgWarn );
	if( @$sett[ 'hdrTrace' ] )
		_ProcessOutHdrTrace( $seraph_accel_g_cacheSkipData[ 0 ], @$seraph_accel_g_cacheSkipData[ 1 ] );

	return( $content );
}

function _CbContentFinish( $content )
{
	global $post;

	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dataPath;
	global $seraph_accel_g_jkfjkexiydyved;
	global $seraph_accel_g_cacheObjChildren;
	global $seraph_accel_g_prepPrms;

	$sett = Plugin::SettGet();
	$settCache = Gen::GetArrField( $sett, array( 'cache' ), array() );

	$skipStatus = ContProcGetSkipStatus( $content );
	if( $skipStatus )
	{
		if( $seraph_accel_g_prepPrms )
		{

			$httpCode = http_response_code();
			if( $httpCode >= 300 && $httpCode < 400 )
				header( 'HTTP/1.1 200 OK' );
		}

		if( !$seraph_accel_g_jkfjkexiydyved && @$sett[ 'hdrTrace' ] )
			_ProcessOutHdrTrace( 'skipped', array( 'reason' => $skipStatus ) );

		CacheDscWriteCancel();

		return( $content );
	}

	$content = trim( apply_filters( 'seraph_accel_content', $content ) );

	$dsc = CacheDscUpdate( $settCache, $content, $seraph_accel_g_cacheObjChildren, $seraph_accel_g_dataPath );

	if( !$dsc )
	{
		if( !$seraph_accel_g_jkfjkexiydyved && @$sett[ 'hdrTrace' ] )
			_ProcessOutHdrTrace( 'skipped', array( 'reason' => 'dscFileUpdateError' ), $seraph_accel_g_dscFile );
		return( $content );
	}

	if( $seraph_accel_g_jkfjkexiydyved )
		return( '' );

	$content = null;
	_ProcessOutCachedData( $sett, $settCache, $dsc, $dscFileTm, @filemtime( $seraph_accel_g_dscFile ), 'revalidated', false, $content );
	return( $content );
}

function GetRequestHost( $serverArgs )
{
	return( strtolower( Net::GetRequestHost( $serverArgs ) ) );
}

function GetCacheSiteIdAdjustPath( $sites, $host, &$path )
{
	if( !is_array( $sites ) )
		return( '_' );

	if( count( $sites ) == 1 )
	{
		$id = Gen::ArrGetByPos( $sites, 0, '', $addrSite );
		$addrSite = Net::Url2Uri( $addrSite );

		$addr = '';
		if( $path )
			$addr .= '/' . $path;

		if( $addr && $addrSite && strpos( $addr, $addrSite ) !== 0 )
			return( '_' );

		$path = ltrim( substr( $addr, strlen( $addrSite ) ), '/' );
		return( $id );
	}

	$addr = $host;
	if( $path )
		$addr .= '/' . $path;

	$addrSite = $addr;
	while( $addrSite != '.' )
	{
		$id = @$sites[ $addrSite ];
		if( $id )
		{
			$path = ltrim( substr( $addr, strlen( $addrSite ) ), '/' );
			return( $id );
		}

		$addrSite = dirname( $addrSite );
	}

	return( '_' );
}

function GetCacheViewId( $settCache, $userAgent, &$args )
{
	$type = 'cmn';
	$stateId = '';

	if( @$settCache[ 'views' ] )
	{
		if( $viewsDeviceGrp = GetCacheViewDeviceGrp( $settCache, $userAgent ) )
			$type = @$viewsDeviceGrp[ 'id' ];

		$viewsGrps = Gen::GetArrField( $settCache, array( 'viewsGrps' ), array() );
		foreach( $viewsGrps as $viewsGrp )
		{
			if( !@$viewsGrp[ 'enable' ] )
				continue;

			$viewsCookies = Gen::GetArrField( $viewsGrp, array( 'cookies' ), array() );
			foreach( $viewsCookies as $e )
			{
				foreach( $_COOKIE as $cookKey => $cookVal )
				{
					if( strpos( $cookKey, $e ) === 0 )
						$stateId .= $cookVal;
				}
			}

			$viewsArgs = Gen::GetArrField( $viewsGrp, array( 'args' ), array() );
			foreach( $viewsArgs as $a )
			{
				foreach( $args as $argKey => $argVal )
				{
					if( strpos( $argKey, $a ) === 0 )
					{
						$stateId .= $argKey . $argVal;
						unset( $args[ $argKey ] );
					}
				}
			}
		}
	}

	{
		$serverArgsTmp = Gen::ArrCopy( $_SERVER ); CorrectRequestScheme( $serverArgsTmp, 'client' );
		if( @$serverArgsTmp[ 'REQUEST_SCHEME' ] == 'http' )
			$type .= '-ns';
	}

	$compatView = ContProcIsCompatView( $userAgent );
	if( $compatView )
		$type .= '-' . $compatView;

	if( $stateId )
		$type .= '-' . md5( $stateId );

	return( $type );
}

