<?php

namespace seraph_accel;

if( !defined( 'ABSPATH' ) )
	exit;

require_once( __DIR__ . '/common.php' );
require_once( __DIR__ . '/oper.php' );
require_once( __DIR__ . '/sql.php' );
require_once( __DIR__ . '/content.php' );
require_once( __DIR__ . '/options.php' );

Plugin::Init();

function OnOptGetDef_Sett()
{
	return( array(

		'cache' => array(
			'enable' => true,
			'lazyInv' => true,

			'updPost' => true,
			'updPostDeps' => array( '/' ),

			'maxProc' => 1,
			'procInterval' => 5,
			'autoProc' => true,

			'timeout' => 12 * 60,
			'timeoutCln' => 30 * 24 * 60,
			'ctxTimeoutCln' => 15 * 24 * 60,
			'autoClnPeriod' => 24 * 60,

			'encs' => array( '', 'gzip', 'deflate', 'compress' ),
			'dataCompr' => array( 'deflate' ),

			'chunks' => array(
				'enable' => true,
				'seps' => array(

				),
			),

			'urisExcl' => array(),
			'exclAgents' => array(
			),
			'exclCookies' => array(),
			'exclArgsAll' => true,

			'exclArgs' => array(
				'aiosp_sitemap_path',
				'aiosp_sitemap_page',
				'xml_sitemap',
				'seopress_sitemap',
				'seopress_news',
				'seopress_video',
				'seopress_cpt',
				'seopress_paged',
				'sitemap',
				'sitemap_n',
			),

			'skipArgsAll' => false,
			'skipArgs' => array( 'redirect_to', 'utm_source', 'utm_medium', 'utm_campaign', 'utm_content', 'utm_term', 'fbclid', 'gclid', '_ga' ),

			'views' => true,
			'viewsDeviceGrps' => array(
				array(
					'enable' => false,
					'name' => '',
					'id' => 'mobilehighres',
					'agents' => array( 'android', 'bada', 'incognito', 'kindle', 'maemo', 'mobi', 'opera mini', 's8000', 'series60', 'ucbrowser', 'ucweb', 'webmate', 'webos', ),
				),

				array(
					'enable' => false,
					'name' => '',
					'id' => 'mobilelowres',
					'agents' => array( '240x320', '2.0 mmp', '\bppc\b', 'alcatel', 'amoi', 'asus', 'au-mic', 'audiovox', 'avantgo', 'benq', 'bird', 'blackberry', 'blazer', 'cdm', 'cellphone', 'danger', 'ddipocket', 'docomo', 'dopod', 'elaine/3.0', 'ericsson', 'eudoraweb', 'fly', 'haier', 'hiptop', 'hp.ipaq', 'htc', 'huawei', 'i-mobile', 'iemobile', 'iemobile/7', 'iemobile/9', 'j-phone', 'kddi', 'konka', 'kwc', 'kyocera/wx310k', 'lenovo', 'lg', 'lg/u990', 'lge vx', 'midp', 'midp-2.0', 'mmef20', 'mmp', 'mobilephone', 'mot-v', 'motorola', 'msie 10.0', 'netfront', 'newgen', 'newt', 'nintendo ds', 'nintendo wii', 'nitro', 'nokia', 'novarra', 'o2', 'openweb', 'opera mobi', 'opera.mobi', 'p160u', 'palm', 'panasonic', 'pantech', 'pdxgw', 'pg', 'philips', 'phone', 'playbook', 'playstation portable', 'portalmmm', 'proxinet', 'psp', 'qtek', 'sagem', 'samsung', 'sanyo', 'sch', 'sch-i800', 'sec', 'sendo', 'sgh', 'sharp', 'sharp-tq-gx10', 'small', 'smartphone', 'softbank', 'sonyericsson', 'sph', 'symbian', 'symbian os', 'symbianos', 'toshiba', 'treo', 'ts21i-10', 'up.browser', 'up.link', 'uts', 'vertu', 'vodafone', 'wap', 'willcome', 'windows ce', 'windows.ce', 'winwap', 'xda', 'xoom', 'zte', ),
				),

				array(
					'enable' => true,
					'name' => '',
					'id' => 'mobile',
					'agents' => array( 'mobile', 'android', 'silk/', 'kindle', 'blackberry', 'opera mini', 'opera mobi', ),
				),
			),
			'viewsGrps' => array(
				array(
					'enable' => true,
					'name' => 'AMP',
					'cookies' => array(),
					'args' => array( 'amp', ),
				),

				array(
					'enable' => true,
					'name' => 'WPML',
					'cookies' => array( 'wp_wcml_currency', ),
					'args' => array( 'lang', ),
				),

				array(
					'enable' => true,
					'name' => 'WPtouch',
					'cookies' => array( 'wptouch-pro-cache-state', 'wptouch-pro-view', ),
					'args' => array(),
				),
			),

			'ctx' => false,
			'ctxSessSep' => true,
			'ctxCliRefresh' => true,
			'ctxGrps' => array(
				'common' => array(
					'enable' => true,
					'name' => 'Common',
					'cookies' => array(
						'wp-postpass_',
						'comment_author_',
						'sc_commented_posts',
					),
					'args' => array(
						'key',
					),

					'tables' => array(

					),
				),

				'wordpress-social-login' => array(
					'enable' => true,
					'name' => 'Social Login',
					'args' => array(
						'action',
					),
				),

				'theme_woodmart' => array(
					'enable' => true,
					'name' => 'WoodMart Theme',
					'cookies' => array(
						'woodmart_wishlist_products',
					),
				),

				'woocommerce' => array(
					'enable' => true,
					'name' => 'WooCommerce',
					'cookies' => array(
						'woocommerce_cart_hash',
						'wp_woocommerce_session_',
					),

					'args' => array(
						'add-to-cart',
						'remove_item',
						'removed_item',
						'undo_item',
						'update_cart',
						'proceed',
						'order_again',
						'apply_coupon',
						'remove_coupon',
					),

					'tables' => array(

					),
				),

				'lifterlms' => array(
					'enable' => true,
					'name' => 'LMS by LifterLMS',

					'tables' => array(

					),
				),
			),
		),

		'cacheBr' => array(
			'enable' => true,
			'timeout' => 30 * 24 * 60,
		),

		'contPr' => array(
			'enable' => true,
			'normalize' => 1|2,

			'min' => true,
			'minCmtsExcl' => array(
				'@^\\s*/?noindex\\s*$@i',
			),

			'earlyPaint' => true,

			'img' => array(
				'srcAddLm' => false,
				'inlSml' => true,
				'inlSmlSize' => 2048,
				'redirWebp' => true,
				'lazy' => array(
					'setSize' => false,
					'load' => true,
					'excl' => array(

					),
				),
			),

			'frm' => array(
				'lazy' => array(
					'enable' => true,
					'yt' => true,
					'vm' => true,

				),
			),

			'js' => array(

				'groupNonCrit' => false,
				'min' => true,
				'minExcls' => array(
				),
				'other' => array(
					'incl' => array(

					),
				),
				'cprRem' => false,
				'optLoad' => true,

				'nonCrit' => array(
					'inl' => true,
					'int' => true,
					'ext' => true,
					'excl' => true,
					'items' => array(

						'body:@\\Wfunction\\s+et_core_page_resource_fallback\\W@',

						'body:@\\WTRINITY_TTS_WP_CONFIG\\W@',
					),

					'timeout' => array(
						'enable' => true,
						'v' => 4500,
					),
				),
				'spec' => array(
					'timeout' => array(
						'enable' => true,
						'v' => 500,
					),
					'items' => array(

					),
				),
				'skips' => array(),
			),

			'css' => array(
				'group' => true,
				'groupNonCrit' => true,
				'min' => true,
				'optLoad' => true,
				'inlAsSrc' => false,
				'inlCrit' => true,
				'inlNonCrit' => false,
				'delayNonCritWithJs' => true,
				'nonCrit' => array(
					'auto' => true,
					'autoExcls' => array(),
					'inl' => true,
					'int' => true,
					'ext' => true,
					'excl' => false,
					'items' => array(),
				),
				'fontOptLoad' => true,
				'fontCrit' => false,
				'skips' => array(),
			),

			'cdn' => array(

				'items' => array(
					array(
						'enable' => true,
						'addr' => '',
						'types' => array( 'js', 'css', 'less', 'gif', 'jpeg', 'jpg', 'bmp', 'png', 'svg', 'eot', 'aac', 'mp3', 'mp4', 'ogg', 'pdf', 'docx', 'otf', 'ttf', 'woff' ),
						'uris' => array( 'wp-content', 'wp-includes' ),
						'urisExcl' => array(),
					),
				),
			),
		),

		'test' => array(
			'contDelay' => false,
			'contDelayTimeout' => 5000,
			'contExtra' => false,
			'contExtraSize' => 0x80000,
		),

		'hdrTrace' => false,
		'debugInfo' => false,
		'debug' => false,
		'emojiIcons' => false,
	) );
}

function OnActivate()
{
	$sett = Plugin::SettGet();
	if( Gen::GetArrField( $sett, 'cache/enable', true, '/' ) )
		CacheInitEnv( $sett, true );
	CacheInitQueueTable( true );
}

function OnDeactivate()
{
	CacheInitEnv( null, false );
}

function OnChangeVer( $verPrev, $pkPrev )
{

}

function _3rdParty_to_boolean( $value )
{
	if( in_array( $value, [ 'yes', 'enabled', 'true', '1', 'on' ], true ) )
		return( true );
	if( in_array( $value, [ 'no', 'disabled', 'false', '0', 'off' ], true ) )
		return( false );
	return( boolval( $value ) );
}

function OnInitAdminMode()
{
	add_action( 'admin_init',
		function()
		{
			if( isset( $_REQUEST[ 'seraph_accel_saveSettings' ] ) )
			{
				unset( $_POST[ 'seraph_accel_saveSettings' ] );
				Plugin::ReloadWithPostOpRes( array( 'saveSettings' => _OnSaveSettings( $_POST ) ) );
				exit;
			}
		}
	);

	add_action( 'seraph_accel_postOpsRes',
		function( $res )
		{
			if( ( $hr = @$res[ 'saveSettings' ] ) !== null )
				echo( Plugin::Sett_SaveResultBannerMsg( $hr, Ui::MsgOptDismissible ) );
		}
	);

	add_action( 'admin_menu',
		function()
		{

			add_menu_page( Plugin::GetPluginString( 'TitleLong' ), Plugin::GetNavMenuTitle(), 'publish_posts', 'seraph_accel_manage', 'seraph_accel\\_ManagePage', Plugin::FileUri( 'icon.png?v=1.8.7', __FILE__ ) );
			add_submenu_page( 'seraph_accel_manage', _x( 'Title', 'admin.Manage', 'seraphinite-accelerator' ), _x( 'Title', 'admin.Manage', 'seraphinite-accelerator' ), 'publish_posts', 'seraph_accel_manage', 'seraph_accel\\_ManagePage' );
			add_submenu_page( 'seraph_accel_manage', Wp::GetLocString( 'Settings' ), Wp::GetLocString( 'Settings' ), 'manage_options', 'seraph_accel_settings', 'seraph_accel\\_SettingsPage' );
		}
	);

	add_action( 'admin_notices',
		function()
		{
			$sett = Plugin::SettGet();

			if( Gen::GetArrField( $sett, 'cache/enable', false, '/' ) )
			{
				{
					$dir = GetCacheDir();
					if( ( !@is_dir( $dir ) && Gen::HrFail( Gen::MakeDir( $dir, true ) ) ) || !@is_writable( $dir ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( 'CacheDirNotWrittable_%1$s', 'admin.Notice', 'seraphinite-accelerator' ), $dir ) ) ) );
				}

				if( !CacheVerifyEnvDropin( $sett ) )
				{
					if( !@file_exists( WP_CONTENT_DIR . '/advanced-cache.php' ) && !@is_writable( WP_CONTENT_DIR ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( 'ContentDirNotWrittable_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), Gen::GetFileName( WP_CONTENT_DIR ), 'advanced-cache.php' ) ) ) );
					else
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( 'ContentDropinNotMatch_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), Gen::GetFileName( WP_CONTENT_DIR ), 'advanced-cache.php' ) ) ) );
				}

				if( !IsWpCacheActive() )
				{
					$cfgFile = Wp::GetConfigFilePath();
					if( !@is_writable( $cfgFile ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( 'ConfigFileNotWrittable_%1$s', 'admin.Notice', 'seraphinite-accelerator' ), $cfgFile ) ) ) );
					else
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', _x( 'WpCacheNotActive', 'admin.Notice', 'seraphinite-accelerator' ) ) ) );
				}

				if( Gen::GetArrField( Plugin::StateGet(), array( 'settChangedUpdateCache' ), false ) )
					echo( Ui::BannerMsg( Ui::MsgWarn,
						Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) .
						Ui::Tag( 'p', vsprintf( esc_html_x( 'SettChangedUpdateCache_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), Ui::Link( array( '', '' ), menu_page_url( 'seraph_accel_manage', false ) . '#operate' ) ) ) .
						Ui::TagOpen( 'input', array( 'type' => 'button', 'class' => 'button button-primary ctlSpaceAfter ctlVaMiddle', 'value' => esc_html( Wp::GetLocString( 'Dismiss' ) ), 'onclick' => 'var ctlMsg=jQuery(this).closest(".notice");jQuery(this).attr("disabled","");ctlMsg.find(".seraph_accel_spinner").show();jQuery.ajax({url:"' . Plugin::GetAdminApiUri( 'StateSet', array( 'settChangedUpdateCache' => '' ) ) . '",type:"post"}).always(function(res){ctlMsg.find(".notice-dismiss").click();});return false;' ) ) .
						Ui::Spinner( false, array( 'style' => array( 'display' => 'none', 'vertical-align' => 'middle' ) ) )
					, Ui::MsgOptDismissible ) );
			}

			if( ( Gen::GetArrField( $sett, 'contPr/normalize', 0, '/' ) & 524288 ) && !Gen::DoesFuncExist( 'tidy_parse_string' ) )
				echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( Wp::SanitizeHtml( _x( 'PhpTidyNotActive_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ) ), 'Tidy', esc_html_x( 'TidyChk', 'admin.Settings_Html_Fix', 'seraphinite-accelerator' ), Ui::Link( esc_html_x( 'Title', 'admin.Settings_Html', 'seraphinite-accelerator' ), menu_page_url( 'seraph_accel_settings', false ) . '#html' ) ) ) ) );

			if( ( in_array( 'br', Gen::GetArrField( $sett, 'cache/encs', array(), '/' ) ) || in_array( 'brotli', Gen::GetArrField( $sett, 'cache/dataCompr', array(), '/' ) ) ) && @version_compare( @phpversion( 'brotli' ), '0.10.0' ) === -1 )
				echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( esc_html_x( 'PhpBrotliNotActive_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), 'Brotli', '0.10.0' ) ) ) );

			{
				$contRemindRefreshCache = vsprintf( esc_html_x( 'RemindRefreshCache_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), Ui::Link( array( '', '' ), menu_page_url( 'seraph_accel_manage', false ) . '#operate' ) );
				$isScriptsDelayLoadEnabled = Gen::GetArrField( $sett, 'contPr/js/optLoad', false, '/' ) && Gen::GetArrField( $sett, 'contPr/js/nonCrit/timeout/enable', false, '/' ) && Gen::GetArrField( $sett, 'contPr/js/nonCrit/timeout/v', 0, '/' );

				for( $theme = wp_get_theme(); $theme && $theme -> parent();  )
					$theme = $theme -> parent();

				if( $theme )
				{
					switch( $theme -> template )
					{
					case 'woostroid2':
						if( $isScriptsDelayLoadEnabled && get_theme_mod( 'page_preloader' ) )
							echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $theme -> name, Wp::GetLocString( 'Show page preloader', null, 'woostroid2' ) ) ) ) );
						break;
					case 'woodmart':
						$themeOpts = get_option( 'xts-woodmart-options' );
						if( $isScriptsDelayLoadEnabled && Gen::GetArrField( $themeOpts, 'lazy_loading', null, '/' ) )
							echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $theme -> name, Wp::GetLocString( 'Lazy loading for images', null, 'woodmart' ) ) ) ) );
						if( $isScriptsDelayLoadEnabled && Gen::GetArrField( $themeOpts, 'preloader', null, '/' ) )
							echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $theme -> name, Wp::GetLocString( 'Preloader', null, 'woodmart' ) ) ) ) );
						break;
					}
				}

				$availablePlugins = Plugin::GetAvailablePluginsEx( true );

				$plg = @$availablePlugins[ 'wp-smushit' ];
				if( $plg )
				{
					$plgOpts = get_option( 'wp-smush-settings' );
					if( $isScriptsDelayLoadEnabled && Gen::GetArrField( $plgOpts, 'lazy_load', null, '/' ) )
						echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $plg[ 'Name' ], Wp::GetLocString( 'Lazy Load', null, 'wp-smushit' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'ewww-image-optimizer' ];
				if( $plg )
				{
					if( $isScriptsDelayLoadEnabled && get_option( 'ewww_image_optimizer_lazy_load' ) )
						echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $plg[ 'Name' ], Wp::GetLocString( 'Lazy Load', null, 'ewww-image-optimizer' ) ) ) ) );
					if( $isScriptsDelayLoadEnabled && get_option( 'ewww_image_optimizer_webp_for_cdn' ) )
						echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $plg[ 'Name' ], Wp::GetLocString( 'JS WebP Rewriting', null, 'ewww-image-optimizer' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'optimole-wp' ];
				if( $plg )
				{
					$plgOpts = wp_parse_args( get_option( 'optml_settings' ) );
					if( $isScriptsDelayLoadEnabled && _3rdParty_to_boolean( Gen::GetArrField( $plgOpts, 'lazyload', null, '/' ) ) )
						echo( Ui::BannerMsg( Ui::MsgWarn, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_DisplayConflict_%1$s%2$s%3$s', 'admin.Notice', 'seraphinite-accelerator' ), $contRemindRefreshCache, $plg[ 'Name' ], Wp::GetLocString( 'Lazyload', null, 'optimole-wp' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'wp-optimize' ];
				if( $plg )
				{
					$plgOpts = get_option( 'wpo_cache_config' );
					if( Gen::GetArrField( $plgOpts, 'enable_page_caching' ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_Conflict_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), $plg[ 'Name' ], Wp::GetLocString( 'Enable page caching', null, 'wp-optimize' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'wp-rocket' ];
				if( $plg )
				{
					if( apply_filters( 'do_rocket_generate_caching_files', true ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_Conflict_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), $plg[ 'Name' ], Wp::GetLocString( 'Cache', null, 'wp-rocket' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'w3-total-cache' ];
				if( $plg )
				{
					echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_Conflict_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), $plg[ 'Name' ], Wp::GetLocString( 'Page Cache', null, 'w3-total-cache' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'nitropack' ];
				if( $plg )
				{
					echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_Conflict_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), $plg[ 'Name' ], Wp::GetLocString( 'Cache', null, 'nitropack' ) ) ) ) );
				}

				$plg = @$availablePlugins[ 'wp-fastest-cache' ];
				if( $plg )
				{
					$plgOpts = @json_decode( get_option( 'WpFastestCache' ), true );
					if( _3rdParty_to_boolean( Gen::GetArrField( $plgOpts, 'wpFastestCacheStatus' ) ) )
						echo( Ui::BannerMsg( Ui::MsgErr, Ui::Tag( 'strong', Plugin::GetPluginString( 'TitleFull' ) ) . Ui::Tag( 'p', sprintf( _x( '3rdSett_Conflict_%1$s%2$s', 'admin.Notice', 'seraphinite-accelerator' ), $plg[ 'Name' ], Wp::GetLocString( 'Cache System', null, 'wp-fastest-cache' ) ) ) ) );
				}
			}
		}
	);

	$sett = Plugin::SettGet();

	if( Gen::GetArrField( $sett, 'cache/updPost', false, '/' ) )
	{
		add_action( 'edit_post',			'seraph_accel\\_OnPostUpdated', 0 );
		add_action( 'publish_post',			'seraph_accel\\_OnPostUpdated', 0 );
		add_action( 'before_delete_post',	'seraph_accel\\_OnPostDeleting', 0 );
	}

	add_action( 'added_option',			'seraph_accel\\_OnUpdateOption', 10 );
	add_action( 'updated_option',		'seraph_accel\\_OnUpdateOption', 10 );
	add_action( 'deleted_option',		'seraph_accel\\_OnUpdateOption', 10 );
}

function OnInit( $isAdminMode )
{
	$sett = Plugin::SettGet();

	$cacheEnable = Gen::GetArrField( $sett, array( 'cache', 'enable' ), false, '/' );

	CacheInitQueueTable();

	add_action( 'init',
		function()
		{
			$sett = Plugin::SettGet();
			if( isset( $sett[ PluginOptions::VERPREV ] ) )
			{
				unset( $sett[ PluginOptions::VERPREV ] );
				Plugin::SettSet( $sett );

				if( Gen::GetArrField( $sett, array( 'cache', 'enable' ), false ) )
					CacheInitEnvDropin( $sett );
				Plugin::StateUpdateFlds( array( 'settChangedUpdateCache' => true ) );
			}
		}
	);

	if( $cacheEnable )
	{
		CacheInitQueueProcessor();
		CacheInitClearProcessor();

		add_action( 'set_logged_in_cookie',
			function( $logged_in_cookie, $expire, $expiration, $user_id, $action, $token )
			{
				UpdateClientSessId( $user_id, $token, $expire );
			},
		10, 6 );

		add_action( 'clear_auth_cookie',
			function( $userId )
			{
				UpdateClientSessId( 0 );
			}
		);
	}

	if( $isAdminMode )
		return;

	if( @$_SERVER[ 'REQUEST_METHOD' ] === 'GET' )
	{
		{
			$settTest = Gen::GetArrField( $sett, array( 'test' ), array() );
			if( ( @$settTest[ 'contDelay' ] || @$settTest[ 'contExtra' ] ) )
				add_action( 'wp_loaded', function() { ob_start( 'seraph_accel\\_OnContentTest' ); } );
		}

	}

	if( $cacheEnable )
	{
		add_action( 'seraph_accel_autoclean', 'seraph_accel\\_OnClean' );

		{
			add_action( 'init',
				function()
				{
					$curUserId = get_current_user_id();
					$token = null;
					$expirationNew = null;
					if( $curUserId )
					{
						$info = wp_parse_auth_cookie( '', 'logged_in' );
						$token = $info[ 'token' ];
						$expirationNew = $info[ 'expiration' ];

						$sett = Plugin::SettGet();

					}

					UpdateClientSessId( $curUserId, $token, $expirationNew );
				}
			);
		}
	}

	if( !Gen::GetArrField( $sett, array( 'emojiIcons' ), true, '/' ) )
		add_action( 'wp_loaded',
			function()
			{
				remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
				remove_action( 'wp_print_styles', 'print_emoji_styles' );
				remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
				remove_filter( 'comment_text_rss', 'wp_staticize_emoji' );
				remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
				add_filter( 'emoji_svg_url', '__return_false' );

			}
	);

}

function _OnClean()
{
	if( GetLoadAvg() > 5 )
		return;

	$settCache = Gen::GetArrField( Plugin::SettGet(), array( 'cache' ), array() );

	$timeout = Gen::GetArrField( $settCache, array( 'timeout' ), 0 ) * 60;
	if( !$timeout )
		return;

}

function _OnUpdateOption( $option )
{
	if( $option != 'siteurl' )
		return;

	$sett = Plugin::SettGet();
	if( Gen::GetArrField( $sett, array( 'cache', 'enable' ), false ) )
		CacheInitEnvDropin( $sett );
}

function _OnPostUpdated( $postId )
{
	global $seraph_accel_g_postUpdated;

	if( $seraph_accel_g_postUpdated && $seraph_accel_g_postUpdated[ $postId ] )
		return;

	CacheOpPost( $postId, 0, 5 );
	$seraph_accel_g_postUpdated[ $postId ] = true;
}

function _OnPostDeleting( $postId )
{
	CacheOpPost( $postId, 2, 5 );
}

function _OnContentTest( $buffer )
{
	$pos = Gen::StrPosArr( $buffer, array( '</body>', '</BODY>' ) );
	if( $pos === false )
		return( $buffer );

	$settTest = Gen::GetArrField( Plugin::SettGet(), array( 'test' ), array() );

	if( @$settTest[ 'contExtra' ] )
	{
		$size = Gen::GetArrField( $settTest, array( 'contExtraSize' ), 0 );
		$extra = GetContentTestData( $size );
		$extra = "\r\n" . Ui::Tag( 'div', $extra, array( 'class' => 'seraph_accel test-random-content size-' . ( $size / 1024 ) . 'KB', 'style' => array( 'display' => 'none' ) ) ) . "\r\n";

		$buffer = substr( $buffer, 0, $pos ) . $extra . substr( $buffer, $pos );
	}

	if( @$settTest[ 'contDelay' ] )
		sleep( Gen::GetArrField( $settTest, array( 'contDelayTimeout' ), 0 ) );

	return( $buffer );
}

function _ManagePage()
{
	Plugin::CmnScripts( array( 'Cmn', 'Gen', 'Ui', 'Net', 'AdminUi' ) );
	wp_enqueue_script( Plugin::ScriptId( 'Admin' ), add_query_arg( Plugin::GetFileUrlPackageParams(), Plugin::FileUri( 'Admin.js', __FILE__, true ) ), array_merge( array( 'jquery' ), Plugin::CmnScriptId( array( 'Cmn', 'Gen', 'Ui', 'Net' ) ) ), '1.8.7' );

	Plugin::DisplayAdminFooterRateItContent();

	$isPaidLockedContent = false;

	$rmtCfg = PluginRmtCfg::Get();
	$sett = Plugin::SettGet();

	{
		Ui::PostBoxes_MetaboxAdd( 'status', esc_html_x( 'Title', 'admin.Manage_Status', 'seraphinite-accelerator' ) . Ui::Tag( 'span', Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Manage_Status' ), Ui::AdminHelpBtnModeBlockHeader ) ), true,
			function( $callbacks_args, $box )
			{
				extract( $box[ 'args' ] );

				echo( Ui::Tag( 'p', Plugin::SwitchToExt(), null, false, array( 'noTagsIfNoContent' => true, 'afterContent' => Ui::SepLine( 'p' ) ) ) );

				echo( Ui::Tag( 'p',
					Ui::Tag( 'div', GetStatusContent( get_option( 'seraph_accel_status' ) ), array( 'class' => array( 'content' ) ) ),
					array( 'data-oninit' => 'seraph_accel.Manager._int.OnStatusRefresh( this, "init" );' )
				) );

				echo( Ui::Tag( 'p',
					Ui::Button( esc_html_x( 'Refresh', 'admin.Manage_Status', 'seraphinite-accelerator' ), false, null, null, 'button', array( 'class' => array( 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnStatusRefresh( this, "push" ); return false;' ) ) .
					Ui::Button( Wp::GetLocString( 'Cancel' ), false, null, null, 'button', array( 'class' => array( 'ctlSpaceAfter', 'cancel' ), 'style' => array( 'min-width' => '7em' ), 'disabled' => true, 'onclick' => 'seraph_accel.Manager._int.OnStatusRefresh( this, "cancel" ); return false;' ) ) .
					Ui::Spinner( false, array( 'class' => 'ctlSpaceAfter', 'style' => array( 'vertical-align' => 'middle', 'display' => 'none' ) ) )
				) );
			},
			get_defined_vars()
		);

		Ui::PostBoxes_MetaboxAdd( 'operate', esc_html_x( 'Title', 'admin.Manage_Operate', 'seraphinite-accelerator' ) . Ui::Tag( 'span', Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Manage_Operate' ), Ui::AdminHelpBtnModeBlockHeader ) ), true,
			function( $callbacks_args, $box )
			{
				extract( $box[ 'args' ] );

				echo( Ui::Tag( 'p', Plugin::SwitchToExt(), null, false, array( 'noTagsIfNoContent' => true, 'afterContent' => Ui::SepLine( 'p' ) ) ) );

				echo( Ui::Tag( 'p', Ui::ComboBox(
					null,
					array(
						'all'			=> esc_html_x( 'Item_All', 'admin.Manage_Operate_Clear', 'seraphinite-accelerator' ),
						'uri'			=> esc_html_x( 'Item_Uri', 'admin.Manage_Operate_Clear', 'seraphinite-accelerator' ),
					),
					'all', false, array( 'class' => 'type', 'style' => array( 'width' => 'auto' ), 'onchange' => 'seraph_accel.Ui.ComboShowDependedItems( this, jQuery( this.parentNode ).closest( ".postbox" ).first().get( 0 ) )' ) ) ) );

				echo( Ui::Tag( 'p', Ui::TextBox( 'seraph_accel_opUrl', '', array( 'class' => 'uri ns-uri ctlSpaceAfter', 'style' => array( 'width' => '100%', 'display' => 'none' ), 'placeholder' => _x( 'UriPhlr', 'admin.Manage_Operate', 'seraphinite-accelerator' ) ), true ) ) );

				echo( Ui::Tag( 'p',
					Ui::Button( esc_html_x( 'Invalidate', 'admin.Manage_Operate', 'seraphinite-accelerator' ), true, null, null, 'button', array( 'class' => array( 'ns-all', 'ns-uri', 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnCacheOp(this,0);return false;' ) ) .
					Ui::Button( esc_html_x( 'Clean', 'admin.Manage_Operate', 'seraphinite-accelerator' ), false, null, null, 'button', array( 'class' => array( 'ns-all', 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnCacheOp(this,1);return false;' ) ) .
					Ui::Button( esc_html_x( 'Delete', 'admin.Manage_Operate', 'seraphinite-accelerator' ), false, null, null, 'button', array( 'class' => array( 'ns-all', 'ns-uri', 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnCacheOp(this,2);return false;' ) ) .
					Ui::Button( Wp::GetLocString( 'Cancel' ), false, null, null, 'button', array( 'class' => array( 'ctlSpaceAfter', 'cancel' ), 'style' => array( 'min-width' => '7em' ), 'disabled' => true, 'onclick' => 'seraph_accel.Manager._int.OnCacheOpCancel(this);return false;' ) ) .
					Ui::Spinner( false, array( 'class' => 'ctlSpaceAfter', 'style' => array( 'vertical-align' => 'middle', 'display' => 'none' ) ) ),
					array( 'data-oninit' => 'seraph_accel.Manager._int.OnCacheOpInit( this, 3000 )' )
				) );
			},
			get_defined_vars()
		);

		Ui::PostBoxes_MetaboxAdd( 'queue', esc_html_x( 'Title', 'admin.Manage_Queue', 'seraphinite-accelerator' ) . Ui::Tag( 'span', Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Manage_Queue' ), Ui::AdminHelpBtnModeBlockHeader ) ), true,
			function( $callbacks_args, $box )
			{
				extract( $box[ 'args' ] );

				echo( Ui::Tag( 'p', Plugin::SwitchToExt(), null, false, array( 'noTagsIfNoContent' => true, 'afterContent' => Ui::SepLine( 'p' ) ) ) );

				echo( Ui::Tag( 'p',
					Ui::Tag( 'div', GetQueueContent( 0 ), array( 'class' => 'content seraph_accel_textarea', 'style' => array( 'overflow' => 'scroll', 'min-height' => '7em', 'height' => '15em', 'max-height' => '30em', 'resize' => 'vertical' ) ) ),
					array( 'data-oninit' => 'seraph_accel.Manager._int.OnQueueRefreshInit(this)' )
				) );

				echo( Ui::Tag( 'p',
					Ui::Button( esc_html_x( 'Delete', 'admin.Manage_Operate', 'seraphinite-accelerator' ), true, null, null, 'button', array( 'class' => array( 'ns-all', 'ns-uri', 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnQueueDel( this );return false;' ) ) .

					Ui::NumberBox( null, 5, array( 'min' => 1, 'class' => 'tmRefresh', 'style' => array( 'width' => '4em', 'display' => 'none' ) ) ) .
					Ui::Spinner( false, array( 'class' => 'ctlSpaceAfter', 'style' => array( 'vertical-align' => 'middle', 'display' => 'none' ) ) )
				) );
			},
			get_defined_vars()
		);

		Ui::PostBoxes_MetaboxAdd( 'htmlChecker', esc_html_x( 'Title', 'admin.Manage_HtmlChecker', 'seraphinite-accelerator' ) . Ui::Tag( 'span', Ui::AdminBtnsBlock( array( array( 'type' => Ui::AdminBtn_Help, 'href' => Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Manage_HtmlChecker' ) ), Plugin::AdminBtnsBlock_GetPaidContent( $isPaidLockedContent ) ), Ui::AdminHelpBtnModeBlockHeader ) ), true,
			function( $callbacks_args, $box )
			{
				extract( $box[ 'args' ] );

				echo( Ui::Tag( 'p', Ui::TextBox( 'seraph_accel_urlCheck', '', array( 'class' => 'url', 'style' => array( 'width' => '100%' ) ), true ) ) );

				echo( Ui::Tag( 'div',
					Ui::CheckBox( esc_html_x( 'LiteChk', 'admin.Manage_HtmlChecker_Fix', 'seraphinite-accelerator' ), null, true, false, array( 'class' => array( 'ctlSpaceAfter', 'ctlSpaceVAfter' ) ), null, array( 'class' => array( 'liteChk' ) ) ) .
					Ui::CheckBox( esc_html_x( 'MedChk', 'admin.Manage_HtmlChecker_Fix', 'seraphinite-accelerator' ), null, false, false, array( 'class' => array( 'ctlSpaceAfter', 'ctlSpaceVAfter' ) ), null, array( 'class' => array( 'medChk' ) ) ) .
					Ui::CheckBox( esc_html_x( 'TidyChk', 'admin.Manage_HtmlChecker_Fix', 'seraphinite-accelerator' ), null, false, false, array( 'class' => array( 'ctlSpaceAfter', 'ctlSpaceVAfter' ) ), null, array( 'class' => array( 'tidyChk' ) ) )
				) );

				echo( Ui::Tag( 'p',
					Ui::Button( esc_html_x( 'Check', 'admin.Manage_Operate', 'seraphinite-accelerator' ), true, null, null, 'button', array( 'class' => array( 'ns-all', 'ns-uri', 'ctlSpaceAfter' ), 'style' => array( 'min-width' => '7em' ), 'onclick' => 'seraph_accel.Manager._int.OnHtmlCheck( this );return false;' ) ) .
					Ui::Spinner( false, array( 'style' => array( 'display' => 'none', 'vertical-align' => 'middle' ) ) )
				) );

				echo( Ui::Tag( 'div', null, array( 'class' => 'seraph_accel_textarea messages', 'style' => array( 'overflow' => 'scroll', 'min-height' => '7em', 'height' => '7em', 'max-height' => '100em', 'resize' => 'vertical' ) ) ) );
			},
			get_defined_vars(), 'body', null, null, false
		);
	}

	{
		$htmlContent = Plugin::GetAdvertProductsContent( 'advertProducts' );
		if( !empty( $htmlContent ) )
			Ui::PostBoxes_MetaboxAdd( 'advertProducts', Plugin::GetAdvertProductsTitle(), false, function( $callbacks_args, $box ) { echo( $box[ 'args' ][ 'c' ] ); }, array( 'c' => $htmlContent ), 'normal' );
	}

	{
		$htmlContent = Plugin::GetRateItContent( 'rateIt', Plugin::DisplayContent_SmallBlock );
		if( !empty( $htmlContent ) )
			Ui::PostBoxes_MetaboxAdd( 'rateIt', Plugin::GetRateItTitle(), false, function( $callbacks_args, $box ) { echo( $box[ 'args' ][ 'c' ] ); }, array( 'c' => $htmlContent ), 'side' );

		$htmlContent = Plugin::SwitchToExt( Plugin::DisplayContent_SmallBlock );
		if( !empty( $htmlContent ) )
			Ui::PostBoxes_MetaboxAdd( 'switchToExt', Plugin::GetSwitchToExtTitle(), false, function( $callbacks_args, $box ) { echo( $box[ 'args' ][ 'c' ] ); }, array( 'c' => $htmlContent ), 'side' );

		$htmlContent = Plugin::GetLockedFeatureLicenseContent( Plugin::DisplayContent_SmallBlock );
		if( !empty( $htmlContent ) )
			Ui::PostBoxes_MetaboxAdd( 'switchToFull', Plugin::GetSwitchToFullTitle(), false, function( $callbacks_args, $box ) { echo( $box[ 'args' ][ 'c' ] ); }, array( 'c' => $htmlContent ), 'side' );

		Ui::PostBoxes_MetaboxAdd( 'about', Plugin::GetAboutPluginTitle(), false, function( $callbacks_args, $box ) { echo( Plugin::GetAboutPluginContent() ); }, null, 'side' );
		Ui::PostBoxes_MetaboxAdd( 'aboutVendor', Plugin::GetAboutVendorTitle(), false, function( $callbacks_args, $box ) { echo( Plugin::GetAboutVendorContent() ); }, null, 'side' );
	}

	Ui::PostBoxes( Plugin::GetSubjectTitle( _x( 'Title', 'admin.Manage', 'seraphinite-accelerator' ) ), array( 'body' => array(  ), 'normal' => array(), 'side' => array(  ) ),
		array(),
		get_defined_vars(),
		array( 'wrap' => array( 'id' => 'seraph_accel_manage' ) )
	);
}

function CacheInitClearProcessor()
{
	if( wp_next_scheduled( 'seraph_accel_cacheClearPeriodically' ) )
		return;

	$settCache = Gen::GetArrField( Plugin::SettGet(), array( 'cache' ), array() );
	if( @$settCache[ 'autoClnPeriod' ] )
		wp_schedule_single_event( time() + @$settCache[ 'autoClnPeriod' ] * 60, 'seraph_accel_cacheClearPeriodically' );
}

add_action( 'seraph_accel_cacheClearPeriodically',
	function()
	{
		CacheInitClearProcessor();
		wp_remote_get( Plugin::GetApiUri( 'CacheCleanupAll', array( 'nonce' => hash_hmac( 'md5', '', NONCE_SALT ), '_' => microtime( true ) ), null ), array( 'timeout' => 0.01, 'blocking' => false, 'sslverify' => false ) );
	}
);

function GetStatusContent( $info = null )
{
	$isPaidLockedContent = false;

	$res = '';

	if( !is_array( $info ) || @$info[ 'v' ] != PLUGIN_STAT_VER )
		$info = null;

	$res .= Ui::SettBlock_Begin( array( 'class' => 'compact' ) );
	{
		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'ObjCountLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) );
		{
			$res .= Ui::Label( $info ? $info[ 'nObj' ] : '-' );
		}
		$res .= Ui::SettBlock_Item_End();

		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'JsCountLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) .  Ui::AdminBtnsBlock( array( Plugin::AdminBtnsBlock_GetPaidContent( $isPaidLockedContent ) ), Ui::AdminHelpBtnModeText ), array( 'style' => array( 'display' => 'none' ) ) );
		{
			$res .= Ui::Label( $info ? $info[ 'nJs' ] : '-' );
		}
		$res .= Ui::SettBlock_Item_End();

		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'CssCountLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) .  Ui::AdminBtnsBlock( array( Plugin::AdminBtnsBlock_GetPaidContent( $isPaidLockedContent ) ), Ui::AdminHelpBtnModeText ), array( 'style' => array( 'display' => 'none' ) ) );
		{
			$res .= Ui::Label( $info ? $info[ 'nCss' ] : '-' );
		}
		$res .= Ui::SettBlock_Item_End();

		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'UsedSpaceLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) );
		{
			$res .= Ui::Label( $info ? size_format( $info[ 'size' ], 1 ) : '-' );
		}
		$res .= Ui::SettBlock_Item_End();

		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'FragEffLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) .  Ui::AdminBtnsBlock( array( Plugin::AdminBtnsBlock_GetPaidContent( $isPaidLockedContent ) ), Ui::AdminHelpBtnModeText ), array( 'style' => array( 'display' => 'none' ) ) );
		{
			$v = $info ? ( sprintf( '%01.0f', 100 * ( 1 - ( $info[ 'sizeObj' ] && $info[ 'sizeObjFrag' ] <= $info[ 'sizeObj' ] ? ( $info[ 'sizeObjFrag' ] / $info[ 'sizeObj' ] ) : 1 ) ) ) . '%' ) : '-';
			$res .= Ui::Label( $v );
		}
		$res .= Ui::SettBlock_Item_End();

		$res .= Ui::SettBlock_Item_Begin( esc_html_x( 'ComprEffLbl', 'admin.Manage_Status', 'seraphinite-accelerator' ) .  Ui::AdminBtnsBlock( array( Plugin::AdminBtnsBlock_GetPaidContent( $isPaidLockedContent ) ), Ui::AdminHelpBtnModeText ), array( 'style' => array( 'display' => 'none' ) ) );
		{
			$v = $info ? ( sprintf( '%01.0f', 100 * ( 1 - ( $info[ 'sizeUncompr' ] && $info[ 'size' ] <= $info[ 'sizeUncompr' ] ? ( $info[ 'size' ] / $info[ 'sizeUncompr' ] ) : 1 ) ) ) . '%' ) : '-';
			$res .= Ui::Label( $v );
		}
		$res .= Ui::SettBlock_Item_End();

	}
	$res .= Ui::SettBlock_End();

	return( $res );
}

function OnApi_UpdateStatus( $args )
{
	if( hash_hmac( 'md5', Gen::SanitizeTextData( @$args[ '_' ] ), NONCE_SALT ) != Gen::SanitizeTextData( @$args[ '_nonce' ] ) )
		return;

	set_time_limit( 1800 );

	$siteId = 'm';

	if( get_option( 'seraph_accel_statusUpdating' ) )
		return;

	_SetExpirableOption( 'seraph_accel_statusUpdating', true, 1800 );

	$optDropCache = new WpOptionDropCache( 'seraph_accel_statusUpdating', 0.5 );
	$info = GetCacheStatusInfo( $siteId,
		function()
		{
			if( !get_option( 'seraph_accel_statusUpdating' ) )
				return( true );

			return( false );
		}
	);

	if( $info )
	{
		$info[ 'v' ] = PLUGIN_STAT_VER;
		update_option( 'seraph_accel_status', $info );

		_DelExpirableOption( 'seraph_accel_statusUpdating' );
	}
}

function OnAdminApi_UpdateStatusBegin( $args )
{
	$ts = '' . microtime( true );
	$urlApi = Plugin::GetApiUri( 'UpdateStatus', array( '_nonce' => hash_hmac( 'md5', $ts, NONCE_SALT ), '_' => $ts ), null );
	$res = wp_remote_get( $urlApi, array( 'timeout' => 0.01, 'blocking' => false, 'sslverify' => false ) );
}

function OnAdminApi_UpdateStatusCancel( $args )
{
	delete_option( 'seraph_accel_statusUpdating' );
}

function OnAdminApi_GetStatusContent( $args )
{
	Plugin::ApiCall_EnableOutput();

	if( !get_option( 'seraph_accel_statusUpdating' ) )
		echo( GetStatusContent( get_option( 'seraph_accel_status' ) ) );
}

function GetViewDisplayNameById( $viewId )
{
	switch( $viewId )
	{
	case 'mobilehighres':	return( esc_html_x( 'ViewMobileHighResTxt', 'admin.Manage_Queue', 'seraphinite-accelerator' ) );
	case 'mobilelowres':	return( esc_html_x( 'ViewMobileLowResTxt', 'admin.Manage_Queue', 'seraphinite-accelerator' ) );
	case 'mobile':			return( esc_html_x( 'ViewMobileTxt', 'admin.Manage_Queue', 'seraphinite-accelerator' ) );
	}

	return( '' );
}

function GetViewDisplayName( $viewName )
{
	$viewId = strpos( $viewName, 'id:' );
	if( $viewId === 0 )
	{
		$viewName = GetViewDisplayNameById( substr( $viewName, 3 ) );
		if( !$viewName )
			$viewName = esc_html_x( 'ViewOtherTxt', 'admin.Manage_Queue', 'seraphinite-accelerator' );
	}
	else if( !$viewName )
		$viewName = esc_html_x( 'ViewComonTxt', 'admin.Manage_Queue', 'seraphinite-accelerator' );

	return( $viewName );
}

function GetQueueContent( $nMaxItems )
{
	$res = '';

	$res .= Ui::TagOpen( 'table' );

	$res .= Ui::Tag( 'thead',
		Ui::Tag( 'th', esc_html_x( 'Address', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		Ui::Tag( 'th', esc_html_x( 'Initiator', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		Ui::Tag( 'th', esc_html_x( 'View', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		Ui::Tag( 'th', esc_html_x( 'State', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		Ui::Tag( 'th', esc_html_x( 'Duration', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		Ui::Tag( 'th', esc_html_x( 'Time', 'admin.Manage_Queue', 'seraphinite-accelerator' ), array( 'style' => array( 'text-align' => 'left' ) ) ) .
		''
	);

	$res .= Ui::TagOpen( 'tbody' );

	if( $nMaxItems )
	{
		$items = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), null, $nMaxItems, null, array( 'state' => 'DESC', 'prior' => 'ASC', 'tm' => 'ASC' ) );
		$tmCur = microtime( true );
		foreach( $items as $item )
		{
			$data = Gen::GetArrField( Gen::Unserialize( @$item[ 'data' ] ), array( '' ), array() );

			$iconClr = '';
			switch( $item[ 'state' ] )
			{
			case 1:
				$state = esc_html_x( 'StateInProgress', 'admin.Manage_Queue', 'seraphinite-accelerator' );
				$iconClr = 'info';
				$initiatorPrior = $item[ 'prior' ];
				$duration = $tmCur - $item[ 'tm' ];
				break;

			case 2:
				$hr = @$data[ 'hr' ];
				$httpCode = Net::GetResponseCodeFromHr( $hr );
				if( $httpCode )
					$error = $httpCode;
				else
					$error = sprintf( '0x%08X', $hr );

				if( $hr == Gen::S_OK )
				{
					$state = esc_html_x( 'StateOk', 'admin.Manage_Queue', 'seraphinite-accelerator' );
					$iconClr = 'success';
				}
				else if( Gen::HrSucc( $hr ) )
				{
					$state = sprintf( esc_html_x( 'StateSkip_%1$s', 'admin.Manage_Queue', 'seraphinite-accelerator' ), $error );
					$iconClr = 'normal';
				}
				else
				{
					$state = sprintf( esc_html_x( 'StateErr_%1$s', 'admin.Manage_Queue', 'seraphinite-accelerator' ), $error );
					$iconClr = 'error';
				}

				$initiatorPrior = @$data[ 'p' ];
				$duration = @$data[ 'td' ];
				break;

			default:
				$initiatorPrior = $item[ 'prior' ];
				$state = esc_html_x( 'StateInitial', 'admin.Manage_Queue', 'seraphinite-accelerator' );
				$duration = null;
				break;
			}

			$initiator = '';
			switch( $initiatorPrior )
			{
			case 0:				$initiator = _x( 'InitiatorSpec', 'admin.Manage_Queue', 'seraphinite-accelerator' ); break;
			case 5:			$initiator = _x( 'InitiatorSpecAuto', 'admin.Manage_Queue', 'seraphinite-accelerator' ); break;
			case 10:	$initiator = _x( 'InitiatorSpecByRequest', 'admin.Manage_Queue', 'seraphinite-accelerator' ); break;
			case 100:				$initiator = _x( 'InitiatorAll', 'admin.Manage_Queue', 'seraphinite-accelerator' ); break;
			}

			if( $duration !== null )
			{
				$duration = gmdate( 'H:i:s', $duration );

			}
			else
				$duration = '';

			$res .= Ui::Tag( 'tr',
				Ui::Tag( 'td', Ui::LogItem( $iconClr, $data[ 'u' ], false ), array( 'class' => 'cellSpaceAfter' ) ) .
				Ui::Tag( 'td', $initiator, array( 'class' => 'ctlNoWrap cellSpaceAfter' ) ) .
				Ui::Tag( 'td', GetViewDisplayName( @$data[ 'v' ] ), array( 'class' => 'ctlNoWrap cellSpaceAfter' ) ) .
				Ui::Tag( 'td', $state, array( 'class' => 'ctlNoWrap cellSpaceAfter' ) ) .
				Ui::Tag( 'td', $duration, array( 'class' => 'ctlNoWrap cellSpaceAfter' ) ) .
				Ui::Tag( 'td', gmdate( 'D, d M Y H:i:s', ( int )$item[ 'tm' ] ) . ' GMT', array( 'class' => 'ctlNoWrap cellSpaceAfter' ) ) .
				''
			, array( 'class' => 'ctlVaTop' ) );
		}
	}

	$res .= Ui::TagClose( 'tbody' );

	$res .= Ui::TagClose( 'table' );

	return( $res );
}

function OnAdminApi_GetQueueContent( $args )
{
	Plugin::ApiCall_EnableOutput();

	$siteId = 'm';

	echo( GetQueueContent( @intval( @$args[ 'nMaxItems' ] ) ) );
}

function OnAdminApi_QueueDelete( $args )
{
	set_time_limit( 1800 );

	$siteId = 'm';

	CachePrepareQueueDelete();
}

function OnApi_CacheRevalidateAll( $args )
{
	if( hash_hmac( 'md5', '', NONCE_SALT ) != Gen::SanitizeTextData( @$args[ 'nonce' ] ) )
		return;

	ignore_user_abort( true );
	set_time_limit( 1800 );

	$siteId = 'm';

	if( CacheOp( $siteId, 0, 100 ) )
		Plugin::StateUpdateFlds( array( 'settChangedUpdateCache' => null ) );
}

function OnApi_CacheCleanupAll( $args )
{
	if( hash_hmac( 'md5', '', NONCE_SALT ) != Gen::SanitizeTextData( @$args[ 'nonce' ] ) )
		return;

	ignore_user_abort( true );
	set_time_limit( 1800 );

	$siteId = 'm';

	CacheOp( $siteId, 1 );

}

function OnApi_CacheOp( $args )
{
	if( hash_hmac( 'md5', Gen::SanitizeTextData( @$args[ '_' ] ), NONCE_SALT ) != Gen::SanitizeTextData( @$args[ '_nonce' ] ) )
		return;

	ignore_user_abort( true );
	set_time_limit( 1800 );

	$siteId = 'm';

	$op = @intval( @$args[ 'op' ] );

	$res = false;
	switch( Wp::SanitizeId( @$args[ 'type' ] ) )
	{
	case 'all':
		if( $res = CacheOp( $siteId, $op, 100 ) )
			Plugin::StateUpdateFlds( array( 'settChangedUpdateCache' => null ) );
		break;
	case 'uri':
		$uri = Net::Url2Uri( Wp::SanitizeUrl( @$args[ 'uri' ] ), true );
		$posAnch = strpos( $uri, '#' );
		if( $posAnch !== false )
			$uri = substr( $uri, 0, $posAnch );
		$uri = trim( $uri, '/' );
		$res = CacheOpUris( $siteId, $uri, $op, 0 );
		break;
	}

}

function OnAdminApi_CacheOpBegin( $args )
{
	$ts = '' . microtime( true );
	$urlApi = Plugin::GetApiUri( 'CacheOp', array_merge( $args, array( '_nonce' => hash_hmac( 'md5', $ts, NONCE_SALT ), '_' => $ts ) ), null );
	$res = wp_remote_get( $urlApi, array( 'timeout' => 0.01, 'blocking' => false, 'sslverify' => false ) );
}

function OnAdminApi_CacheOpCancel( $args )
{
	$siteId = 'm';
	CacheOpCancel( $siteId );
}

function OnAdminApi_CacheGetCurOp( $args )
{
	$siteId = 'm';
	return( CacheGetCurOp( $siteId ) );
}

function OnAdminApi_HtmlCheck( $args )
{
	set_time_limit( 300 );

	$url = Wp::SanitizeUrl( @$args[ 'url' ] );
	if( strpos( $url, '//' ) === 0 )
		$url = 'http:' . $url;
	else if( strpos( $url, '://' ) === false )
		$url = 'http://' . $url;

	$requestRes = Wp::RemoteGet( $url, array( 'timeout' => 15, 'sslverify' => false ) );
	if( is_wp_error( $requestRes ) )
		return( array( 'err' => $requestRes -> get_error_message() ) );

	$validationErrors = array();

	if( !$validationErrors )
		$validationErrors[] = array( 'severity' => 'success', 'text' => esc_html_x( 'Ok', 'admin.Manage_HtmlChecker_Msg', 'seraphinite-accelerator' ) );

	return( array( 'err' => '', 'list' => $validationErrors ) );
}

function OnAdminApi_StateSet( $args )
{
	$fields = array();
	foreach( $args as $id => $val )
		$fields[ Wp::SanitizeId( $id ) ] = $val != '' ? Wp::SanitizeText( $val ) : null;

	Plugin::StateUpdateFlds( $fields );
}

